#include <hmg.ch>
#include <common.ch>
#include <Directry.ch>
#include 'fileio.ch'
*
# DEFINE _NAME  1
# DEFINE _SIZE  2
# DEFINE _DATE  3
# DEFINE _TIME  4
*
Procedure LetoSaveFiles(cOrigin,cTarget,lForce,lFolders,lFiles,cDrive)
  LOCAL aFolders1
  LOCAL aFolders2
  LOCAL aSourgeA
  LOCAL aSourgeB
  LOCAL aTargetA
  LOCAL aTargetB
  LOCAL i
  LOCAL j
  LOCAL a1                                          // array temporary
  LOCAL a3                                          // files changed
  LOCAL a4                                          // files deleted
  LOCAL a5                                          // array temporary
  LOCAL a6                                          // folders deleted
  LOCAL a7                                          // new files
  LOCAL a7b                                         // new files do not copied
  LOCAL a3b                                         // files changed do not copied
  LOCAL a8                                          // files do not copied
  LOCAL a9                                          // files do not written on disk
  LOCAL Tot1                                        // bytes files
  LOCAL Tot2                                        // bytes files
  LOCAL nDiskFree                                   // diskspace
  LOCAL nPos
  LOCAL lChange
  Local c1
  Local n
  Local Time1
  Local Time2
  Local nLenA
  Local nLenB
  Local lsamepath
  Local lDownloadfromserver
  Local cDrive2
  Local cDrive3
  Local lOK
  *
  hb_Default(@lForce,.F.)
  *
  If Empty(cDrive)                                  // copia sul server
     lDownloadfromserver := .F.
  else                                              // copia dal server
     lDownloadfromserver := .T.
  endif
  *
  Time1    := Time()
  *
  Out_List_1('')
  Out_List_1('')
  Out_List_1('TYPE BACKUP '+if(lForce,'FULL','INCREMENTAL'))
  Out_List_1('**********************************************')
  Out_List_1('Day..................: '+DToC(date())+' Time '+Time1)
  *
  If !lDownloadfromserver                                        // copia su server
     Out_List_1('Folder Origin........: '+cDrive+cOrigin)
     Out_List_1('Folder Target........: '+LetoPath+cTarget)
     cDrive3 := LetoPath
     cDrive2 := Left(cOrigin,2)
  else                                              // copia dal server
     Out_List_1('Folder Origin........: '+LetoPath+cOrigin)
     Out_List_1('Folder Target........: '+cDrive+cTarget)
     cDrive3 := cDrive
  endif
  *
  Out_List_1('**********************************************')
  *
  aFolders1   := {}
  aFolders2   := {}
  aSourgeA    := {}
  aSourgeB    := {}
  aTargetA    := {}
  aTargetB    := {}
  Tot1        := 0
  Tot2        := 0
  a3          := {}
  a4          := {}
  a5          := {}
  a6          := {}
  a7          := {}
  a3b         := {}
  a7b         := {}
  a8          := {}
  a9          := {}
  aTemp1      := {}
  aTemp2      := {}
  cDrive2     := ''
  *
  nDiskFree   := HB_DiskSpace(cDrive)
  *
  Out_List_1('Wait...data reading.......')
  *
  If Trim(cOrigin) == Trim(Substr(cTarget,3))       // stesso path
     lsamepath := .T.
  else                                              // path diverso
     lsamepath := .F.
  endif
  *
  *
  aTemp1 := StToAr(cOrigin,'\')
  aTemp2 := StToAr(cTarget,'\')
  *
  WAIT WINDOW [..........Attendere..........] NOWAIT
     If lDownloadfromserver                                         // copia dal server
        Leto_Scandir2(cOrigin,ASourgeB,aFolders1)
        Scandir2(cDrive+cTarget,aTargetB,aFolders2)
     else                                              // copia sul server
        Scandir2(cDrive+cOrigin,aTargetB,aFolders2)
        Leto_Scandir2(cTarget,ASourgeB,aFolders1)
     Endif
  WAIT CLEAR
  *
  nLenA := Len(cOrigin)+1
  nLenB := Len(cTarget)+1
  *
  if lsamepath                                         // stesso path
     if lDownloadfromserver                                       // copia dal server
        For j := 1 To Len(aFolders1)
           c1 := aFolders1[j]
           MakeDir(cDrive+Left(c1,Len(c1)-1))
        Next
     else                                            // copia sul server
        For j := 1 To Len(aFolders1)
           c1 := Substr(aFolders1[j],nLenA)
           MakeDir(cDrive+cTarget+Left(c1,Len(c1)-1))
        Next
     endif
  else                                              //  path diverso
     if lDownloadfromserver                                       // copia dal server
        For j := 1 To Len(aFolders1)
           c1 := Substr(aFolders1[j],nLenA)
           MakeDir(cDrive+cTarget+Left(c1,Len(c1)-1))
        Next
     else                                            // copia sul server
        For j := 1 To Len(aFolders2)
           c1 := aFolders2[j]
           Leto_MakeDir(c1)
        Next
     endif
  endif
  *
  For i := 1 To Len(aSourgeB)
     a1 := {}
     For J := 1 To Len(aSourgeB[i])
        If j == 1
           c1 := aSourgeB[i,j]
           aadd(a1,c1)
        else
           aadd(a1,aSourgeB[i,j])
        endif
     Next
     If lDownloadfromserver
        aadd(aSourgeA,a1)
     else
        aadd(aTargetA,a1)
     endif
  Next
  *
  For i := 1 To Len(aTargetB)
     a1 := {}
     For J := 1 To Len(aTargetB[i])
        If j == 1
           c1 := aTargetB[i,j]
           aadd(a1,c1)
        else
           aadd(a1,aTargetB[i,j])
        endif
     Next
     If lDownloadfromserver
        aadd(aTargetA,a1)
     else
        aadd(aSourgeA,a1)
     Endif
  Next
  *
  Out_List_1('Check Changes to be made on Folder '+cDrive3+cTarget)
  Out_List_1('Wait...........')
  *
  FOR i := 1 TO Len(aSourgeA)
     *
     If chr(126) $ aSourgeA[i,_NAME]
        Loop
     Endif
     *
     Tot2 += aSourgeA[i,_SIZE]
     *
     If lsamepath                                       // stesso path
        If lDownloadfromserver                                     // copia dal server
           nPos := AScan(aTargetA,{|_a| Trim(Upper(_a[1])) == Trim(Upper(aSourgeA[i,_NAME])) })
        else                                          // copia sul server
           nPos := AScan(aTargetA,{|_a| Substr(Upper(_a[1]),nLenB) == Substr(Upper(aSourgeA[i,_NAME]),nLenA) })
        endif
     else                                            // path diverso
        If lDownloadfromserver                                     // copia dal server
           nPos := AScan(aTargetA,{|_a| Substr(Upper(_a[1]),nLenB) == Substr(Upper(aSourgeA[i,_NAME]),nLenA) })
        else                                          // copia sul server
           nPos := AScan(aTargetA,{|_a| Trim(Upper(_a[1])) == Trim(Upper(aSourgeA[i,_NAME])) })
        endif
     endif
     *
     IF nPos == 0
        If lsamepath                                     // stesso path
           If lDownloadfromserver                                   // copia dal server
              AAdd(a7,{aSourgeA[i,_NAME],aSourgeA[i,_NAME]})
           else                                        // Path diverso
              AAdd(a7,{aSourgeA[i,_NAME],cTarget+Substr(Upper(aSourgeA[i,_NAME]),nLenA)})
           Endif
        else                                          // path diverso
           If lDownloadfromserver                                   // copia dal server
              AAdd(a7,{aSourgeA[i,_NAME],cTarget+Substr(Upper(aSourgeA[i,_NAME]),nLenA)})
           else
              AAdd(a7,{aSourgeA[i,_NAME],aSourgeA[i,_NAME]})
           endif
        endif
        Tot1 += aSourgeA[i,_SIZE]
     ELSE
        aTargetA[nPos,5] := .T.
        *
        lChange := .F.
        IF aSourgeA[I,6] > aTargetA[nPos,6]
           lChange := .T.
        ENDIF
        IF lForce
           lChange := .T.
        ENDIF
        *
        IF lChange
           If lsamepath                                   // stesso path
              If lDownloadfromserver                                 // Copia dal server
                 AAdd(a3,{aSourgeA[i,_NAME],aSourgeA[i,_NAME]})
              else                                      // copia sul server
                 AAdd(a3,{aSourgeA[i,_NAME],cTarget+Substr(Upper(aSourgeA[i,_NAME]),nLenA)})
              endif
           else                                        // path diverso
              If lDownloadfromserver                                 // Copia dal server
                 AAdd(a3,{aSourgeA[i,_NAME],cTarget+Substr(Upper(aSourgeA[i,_NAME]),nLenA)})
              else                                      // copia sul server
                 AAdd(a3,{aSourgeA[i,_NAME],aSourgeA[i,_NAME]})
              endif
           endif
        ENDIF
     ENDIF
  NEXT
  *
  IF lFiles
     Out_List_1('Delete files that are no longer...')
     FOR i := 1 TO Len(aTargetA)
        IF aTargetA[i,5] == .F.
           if lDownloadfromserver
              lOk := File(cDrive+aTargetA[i,1])
           else
              lOk := Leto_File(cDrive+aTargetA[i,1])
           endif
           If lOk
              AAdd(a4,cDrive+aTargetA[i,1])
              FErase(cDrive+aTargetA[i,1])
           ENDIF
        Endif
     NEXT
  ENDIF
  *
  IF lFolders
     *
     Out_List_1('Delete folders that are no longer...')
     *
     If lDownloadfromserver                                       // copia da server
        FOR i := 1 TO Len(aFolders2)
           nPos := AScan(aFolders1,{|_a| Upper(_a) == Upper(aFolders2[i]) })
           IF nPos == 0
              AAdd(a6,{Upper(aFolders2[i]),OCCURS('\',aFolders2[i])})
           ENDIF
        NEXT
     else                                            // copia sul server
        FOR i := 1 TO Len(aFolders1)
           nPos := AScan(aFolders2,{|_a| Upper(_a) == Upper(aFolders1[i]) })
           IF nPos == 0
              AAdd(a6,{Upper(aFolders1[i]),OCCURS('\',aFolders1[i])})
           ENDIF
        NEXT
     Endif
     *
     ASort(a6,,,{|x,y| x[2] < y[2] })
  ENDIF
  *
  IF Empty(a3) .and. Empty(a7)
     IF !Empty(a4) .or. !Empty(a6)
        Out_List_1('**********Files Deleted**********')
        FOR i := 1 TO Len(a4)
           Out_List_1(a4[i])
        NEXT
        Out_List_1('**********Folders Deleted********')
        *
        FOR i := Len(a6) TO 1 STEP -1
           if lDownloadfromserver
              lOk := DirRemove(cDrive+a6[i,1]) == 0
           else
              lOk := Leto_DirRemove(cDrive+a6[i,1]) == 0
           endif
           If lOk
              Out_List_1(cDrive+a6[i,1])
           ENDIF
        NEXT
        Out_List_1('')
        Out_List_1('**********operation completed successfully!**********')
        Out_List_1('')
        Time2 := Time()
        Out_List_1('Day '+DToC(date())+' Elap Time '+ElapTime(Time1,Time2)+' - '+'Folder: '+cDrive3+cTarget)
        *
     ELSE
        Out_List_1('No data to update the folder '+cDrive3+cTarget)
        Out_List_1('')
        Out_List_1('**********operation completed successfully!**********')
        Out_List_1('')
        Time2 := Time()
        Out_List_1('Day '+DToC(date())+' Elap Time '+ElapTime(Time1,Time2)+' - '+'Folder: '+cDrive3+cTarget)
        Out_List_1('')
        Out_List_1('')
        Out_List_1('')
     ENDIF
  ELSE
     IF nDiskFree < (Tot1-Tot2)
        MsgInfo('Insufficient space on Drive '+cDrive3)
     ELSE
        IF !Empty(a7)
           Out_List_1('Copy new files')
           FOR i := 1 TO Len(a7)
              If LetoCopyFileOK(a7[i,1],cDrive+a7[i,2],lDownloadfromserver,cDrive2)
                 Out_List_1(cDrive+a7[i,2])
              ELSE
                 AAdd(a7b,a7[i,2])
              ENDIF
           NEXT
        ENDIF
        *
        IF !Empty(a3)
           Out_List_1('Copy files changed')
           FOR i := 1 TO Len(a3)
              IF LetoCopyFileOK(a3[i,1],cDrive+a3[i,2],lDownloadfromserver,cDrive2)
                 Out_List_1(cDrive+a3[i,2])
              ELSE
                 AAdd(a3b,a3[i,2])
              ENDIF
           NEXT
        ENDIF
        *
        Out_List_1('**********New Files NOT Copied**********')
        FOR i := 1 TO Len(a7b)
           Out_List_1(cDrive+a7b[i])
        NEXT
        Out_List_1('**********Files Changed NOT Copied**********')
        FOR i := 1 TO Len(a3b)
           Out_List_1(a3b[i])
        NEXT
        *
        Out_List_1('**********Files Deleted**********')
        FOR i := 1 TO Len(a4)
           Out_List_1(a4[i])
        NEXT
        Out_List_1('**********Folders Deleted*******')
        FOR i := Len(a6) TO 1 STEP -1
           if lDownloadfromserver
              lOk := DirRemove(a6[i,1]) == 0
           else
              lOk := Leto_DirRemove(a6[i,1]) == 0
           endif
           If lOk
              Out_List_1(a6[i,1])
           ENDIF
        NEXT
        *
        Out_List_1('')
        FOR i := 1 TO Len(a3)
           if lDownloadfromserver
              lOK:=  File(cDrive+a3[i,2])
           else
              lOK:=  Leto_File(cDrive+a3[i,2])
           endif
           If !lOk
              AAdd(a8,{a3[i,1],a3[i,2]})
           ENDIF
        NEXT
        FOR i := 1 TO Len(a7)
           If lDownloadfromserver
              lOK := File(cDrive+a7[i,2])
           else
              lOK := Leto_File(cDrive+a7[i,2])
           endif
           If !lOk
              AAdd(a8,{a7[i,1],a7[i,2]})
           ENDIF
        NEXT
        IF Empty(a8)
           Out_List_1('')
           Out_List_1('**********operation completed successfully!**********')
           Out_List_1('')
           Time2 := Time()
           Out_List_1('Day '+DToC(date())+' Elap Time '+ElapTime(Time1,Time2)+' - '+'Folder: '+cDrive3+cTarget)
        ELSE
           FOR i := 1 TO Len(a8)
              LetoCopyFileOK(a8[i,1],cDrive+a8[i,2],lDownloadfromserver,cDrive2)
           NEXT
           FOR i := 1 TO Len(a8)
              IF lDownloadfromserver
                 lOK := File(cDrive+a8[i,2])
              else
                 lOK := Leto_File(cDrive+a8[i,2])
              endif
              If !lOk
                 AAdd(a9,a8[i,2])
              ENDIF
           NEXT
           Out_List_1('')
           Out_List_1('This files Have not been written to disk:')
           FOR i := 1 TO Len(a9)
              Out_List_1(cDrive+a9[i])
           NEXT
           Out_List_1('')
           Out_List_1([**********it is advisable to repeat!**********])
           Out_List_1('')
           Time2 := Time()
           Out_List_1('Day '+DToC(date())+' Elap Time '+ElapTime(Time1,Time2)+' - '+'Folder: '+cDrive3+cTarget)
        ENDIF
     ENDIF
  ENDIF
  *
RETURN
*
FUNCTION Leto_Scandir2(cDir,aRay,aFolders)
  LOCAL i
  LOCAL a1
  LOCAL a2
  *
  IF Right(cDir,1) != '\'
     cDir += '\'
  ENDIF
  *
  a1 := Leto_ReadDir2({cDir},aRay)
  *
  FOR i := 1 TO Len(a1)
     AAdd(aFolders,a1[i])
  NEXT
  *
  DO WHILE .T.
     a2 := Leto_ReadDir2(a1,aRay)
     IF Empty(a2)
        EXIT
     ENDIF
     a1 := AClone(a2)
     FOR i := 1 TO Len(a1)
        AAdd(aFolders,a1[i])
     NEXT
  ENDDO
  *
RETURN
*
STATIC FUNCTION Leto_ReadDir2(a,aRay)
  LOCAL i
  LOCAL j
  LOCAL aDirTmp
  LOCAL aFiles
  *
  aDirTmp := {}
  FOR j := 1 TO Len(a)
     aFiles := Leto_Directory(a[j]+'','DH')
     FOR i := 1 TO Len(aFiles)
        IF 'D' $ aFiles[i,F_ATTR].and. Left(aFiles[i,F_NAME],1) != '.'
           AAdd(aDirTmp,a[j]+aFiles[i,F_NAME]+'\')
        ELSEIF Left(aFiles[i,F_NAME],1) != '.'
           AAdd(aRay,{;
           a[j]+aFiles[i,F_NAME],;
           aFiles[i,F_SIZE],;
           Val(DToS(aFiles[i,F_DATE])),;
           Secs(aFiles[i,F_TIME]),;
           FALSE,;
           Val(DToS(aFiles[i,F_DATE])+StrZero(Secs(aFiles[i,F_TIME]),5))})
        ENDIF
     NEXT
  NEXT
  *
RETURN aDirTmp
*
FUNCTION LetoCopyFileOK( src, dst ,lDownloadfromserver,cDrive2)
  Local nSize
  Local c1
  Local lOk := .F.
  *
  private dDate,cTime
  *
  If lDownloadfromserver                                         //copia dal server
     dDate := Leto_FileTime(src,,,2)
     cTime := Leto_FileTime(src,,,4)
     nSize := Leto_FileSize(src)
     *
     c1 := Substr(src,Rat('\',src)+1)
     If nSize > 5700*8
        CopyFromServer(dst,src,c1)
     else
        Leto_FCopyFromSrv(dst,src)
     endif
     hb_FSetDateTime(dst ,dDate, cTime )
     lOK := .T.
  else                                              // copia sul server
     If Leto_FCopyToSrv(cDrive2+src,dst)
        HB_FGETDATETIME( src , @dDate, @cTime  )
        Leto_FileTime(src,dDate,cTime,4)
        lOK := .T.
     endif
  endif
  *
Return lOk
*
Procedure CopyfromServer(cLocalfile,cServerFile,cFileName)
  Local nHandle
  Local nHandle2
  Local nBytes
  Local nTotBytes
  Local cBuff
  Local Count
  Local x
  Local y
  Local x1,x2,x3
  *
  nTotBytes := Leto_FileSize(cServerFile)
  nBytes    := 5700*8
  nHandle   := Leto_Fopen(cServerFile)
  cBuff     := space(nBytes)
  *
  nHandle2 := FCreate(cLocalFile)
  *
  x := int((nTotBytes/nBytes)/100)
  *
  *a1 := {'25%','50%','75%','100%'}
  x2 := int(x/2)
  x1 := int(x2/2)
  x3 := x2+x1
  *n3 := 0
  Count := 0
  y     := 0
  Do While (!Leto_Feof(nHandle))
     *
     ++Count
     If Count == x
        ++y
        Count := 0
        IF y == 25 .or. y == 50 .or. y == 75
           *SendToLog('(D0) - '+Time()+' ('+a1[++n3]+')'+'-Download '+Trim(cFilename))
        Endif
     Endif
     *
     Leto_Fread(nHandle,@cBuff,nBytes)
     FWrite(nHandle2,cBuff)
     nTotBytes -= nBytes
     If nTotBytes < nBytes
        nBytes := nTotBytes
        cBuff  := space(nBytes)
     Endif
     *
  Enddo
  Leto_FClose(nHandle)
  FClose(nHandle2)
  *
Return
*
